#ifdef TRWIN

	#include "stdafx.h"
	#include "math.h"
	#include "N64Em.h"
	#include "registers.h"
	#include "N64CPU.h"

#else

extern "C"

{

extern int UseNew;

	#define SafeFree(ptr) if(ptr!=NULL) free(ptr); ptr=NULL;

	#include <type_sizes.h>	

	#include "registers.h"

	extern struct rs4300i_reg reg;
	struct rs4300i_reg *m_Reg=&reg;
	#define Lo lo
	#define Hi hi
	#define Delay delay
	#define DoOrCheckSthg do_or_check_sthg
	#define CPR cpr
	#define PC pc
	#define Llbit llbit
	#define DO_SI_INTERRUPT RS4300I_DO_SI_INTERRUPT
	#define DO_SP_INTERRUPT RS4300I_DO_SP_INTERRUPT
	#define DO_DP_INTERRUPT RS4300I_DO_DP_INTERRUPT
	#define DO_AI_INTERRUPT RS4300I_DO_AI_INTERRUPT
	#define DO_PI_INTERRUPT RS4300I_DO_PI_INTERRUPT

	#define CHECK_MI_INTERRUPTS RS4300I_CHECK_MI_INTERRUPTS
	#define CHECK_CPU_INTERRUPTS RS4300I_CHECK_CPU_INTERRUPTS

	#define helperStoreDWord doWriteMemDoubleWord
	#define helperStoreWord doWriteMemWord
	#define helperStoreHalf doWriteMemHalfWord
	#define helperStoreByte doWriteMemByte

	#define helperLoadDWord doReadMemDoubleWord
	#define helperLoadWord doReadMemWord
	#define helperLoadHalf doReadMemHalfWord
	#define helperLoadByte doReadMemByte

#endif

/*
	unsigned __int32 len=LoadReg(unsigned char *cp,unsigned char MReg)
	Checks to see if MReg is already mapped, if so, loads from RegisterMemory into the NReg, map is marked !Dirty
	Calls GetFreeReg(), load from RegisterMemory in NReg,
	If no free registers are available, uses IsUsed to try and find a discardable NReg and uses that
	If no register can be discarded, calls FlushReg to free up a register slot.
	80201680
*/

#include "dynaCompiler.h"
#include "dynains.h"

// #define PASS_MEM		// not needed now

#define JALn
#define JALRn
#define JRn
#define Jn
#define BEQn
#define BNEn

#define BEQLn
#define BNELn

#define BLTZn
#define BLEZn
#define BGTZn
#define BGEZn

#define BLTZLn
#define BLEZLn
#define BGTZLn
#define BGEZLn

#define BLTZALn
#define BLEZALn
#define BGTZALn
#define BGEZALn

#define BLTZALLn
#define BLEZALLn
#define BGEZALLn

#define BCFn
#define BCTn
#define BCFLn
#define BCTLn

#define ALL_ILOOP

unsigned __int32 InterpHelperAddress;
unsigned __int32 helperLoadDWordAddress;
unsigned __int32 helperLoadWordAddress;
unsigned __int32 helperLoadHalfAddress;
unsigned __int32 helperLoadByteAddress;
unsigned __int32 helperStoreDWordAddress;
unsigned __int32 helperStoreWordAddress;
unsigned __int32 helperStoreHalfAddress;
unsigned __int32 helperStoreByteAddress;
unsigned __int32 helperCheckIntsAddress;
//unsigned __int32 ICountPtr;
//unsigned __int32 CompareCountPtr;
unsigned __int32 SneekyAddress;
unsigned __int32 dynaPC;
unsigned __int32 dynaVCount=0;
unsigned __int32 dynaICount=0;
unsigned char dynaInBranch;
unsigned char *dynaHold;

#ifdef TRWIN
	extern	RS4300iReg *m_Reg;		// owned by N64CPU
	extern N64CPU *helper;
#else

#endif

extern void dynaCheckInts();
unsigned __int32 dynaCheckIntsAddress;

#define GPR0_OPTIMIZATION

// these are the magic numbers.  they are the offsets into the CPU Register structure.  Dyna keeps a pointer to the
// base and then indexes in to get the various registers. On the Intel, EBP is set to the base.

#define GPR 0					//   0
#define CPR0 GPR+256			// 256
#define CPR1 CPR0+256			// 512
#define CPR2 CPR1+256			// 768
#define CCR0 CPR2+256			//1024
#define CCR1 CCR0+256			//1280
#define CCR2 CCR1+256			//1536
#define _FPR  CCR2+256			//1792
#define LO   _FPR+128			//1920
#define HI   LO+8				//1928
#define PC_   HI+8				//1936
#define PCDELAY PC_+4			//1940
#define DELAY   PCDELAY+4		//1944
#define DORC DELAY+4			//1948
#define HLT_  DORC+4			//1952
#define CODE HLT_+4				//1956
#define LAST_PC CODE+4			//1960
#define TMP_ LAST_PC+4			//1964
#define LL TMP_+4				//1968
#define ICOUNT 1976
#define CCOUNT 1984
#define NCOUNT CCOUNT+8			//1992
#define VCOUNT NCOUNT+8			//2000 (or 0 for you y2k fans)
#define ROUND VCOUNT+8			//2008	
#define TRUNC ROUND+4			//2012
#define CEIL TRUNC+4			//2012
#define FLOOR CEIL+4			//2012


// For Intel
#define NATIVE_REGS 4		// eax,ebx,ecx are available;  
							// edx,esi,edi & esp are reserved
							// edi always points to RegisterMemory
							// esi is reserved for registers used as a memory read pointer
							// edi is reserved for registers used as a memory write pointer
							// esp is the stack pointer

#define NATIVE_0 0		//EAX
#define NATIVE_1 3		//EBX
#define NATIVE_2 1		//ECX
#define NATIVE_3 2		//EDX
#define MEM_PTR 6		//ESI
#define PC_PTR  7		//EDI
#define REG_PTR  5		//EBP


typedef struct reg_map
{
	unsigned char Reg;				// register number
	unsigned __int32 BirthDate;		// 'year' the register was mapped.
	unsigned char Dirty;				// true if register is modified after loading; ie the results of an operation
} dynaRegMap;

dynaRegMap dynaMapToNative[32];	// index is MIPS GPR, value is the Native register currently mapped to
								// Dirty flag marks the register if it has been modified since load
								// 0xff if register is not mapped

dynaRegMap dynaMapToMips[NATIVE_REGS];	// index is Native register, value is the MIPS GPR currently mapped
										// Dirty flag marks the register if it has been modified since load
										// 0xff if register is not mapped
dynaRegMap buffer[2048];

unsigned char dynaNumFreeRegs;			// number of 'free' Native registers

unsigned __int32 dynaBirthYear;			// the 'year' that any newly mapped registers will be 'born' on. used to determine
								// which registers should flush out when we need space in the Native register set
								// incremented everytime a register is loaded or modified.

void dynaMarkRegDirty(unsigned char MipsReg,unsigned char IsDirty)
{
	dynaMapToNative[MipsReg].Dirty=IsDirty;
	dynaMapToMips[dynaMapToNative[MipsReg].Reg].Dirty=IsDirty;
}

unsigned char dynaIsUsed(unsigned char MipsReg)
{
	return(true);
}

unsigned char dynaGetFreeReg()
{
	for(unsigned char i=0;i<NATIVE_REGS;i++)
	{
		if(dynaMapToMips[i].Reg==0xff)	// 0xff marks an unmapped register
			return(i);
	}
	return(0xff);			// error case, should not be reached
}

#define MAKE_RS            (((unsigned char)(dynaOpCode >> 21)) & 0x1f)

#define MAKE_RT            (((unsigned char)(dynaOpCode >> 16)) & 0x1f)

#define MAKE_RD            (((unsigned char)(dynaOpCode >> 11)) & 0x1f)

#define MAKE_SA            (((unsigned char)(dynaOpCode >>  6)) & 0x1f)

#define MAKE_F             ( (unsigned char)(dynaOpCode)        & 0x3f)

#define MAKE_I             ( (short)(dynaOpCode&0xffff) )
#define MAKE_IU            ( (unsigned __int16)(dynaOpCode&0xffff) )

#define MAKE_FMT MAKE_RS
#define MAKE_FT MAKE_RT
#define MAKE_FS MAKE_RD
#define MAKE_FD MAKE_SA

#define FMT_S   16      /* 32bit binary floating-point */
#define FMT_D   17      /* 64bit binary floating-point */
#define FMT_W   20      /* 32bit binary fixed-point    */
#define FMT_L   21      /* 64bit binary fixed-point    */

#define MAKE_O             ( dynaPC + (__int32)(MAKE_I << 2) +4)
#define ____T             (dynaOpCode & 0x00ffffff)
#define MAKE_T            (((dynaPC & 0xf0000000) | (____T << 2) ))

#include "dynaNative.h"		// functions that map to native processor
#include "dmult.h"

unsigned char NMAP[32]={NATIVE_0,NATIVE_1,NATIVE_2,NATIVE_3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

unsigned __int16 dynaFlushReg(unsigned char *cp,unsigned char NReg)
{
	return(STORE_REG(cp,dynaMapToMips[NReg].Reg,NReg));		// store the Native register in Mips register memory
}

unsigned __int16 dynaKillNative(unsigned char NReg)
{
	return(0); //broken for now	
	dynaMapToNative[dynaMapToMips[NReg].Reg].Reg=0xff;
	dynaMapToMips[NReg].Reg=0xff;
	return(0);
}

// When dynaCompiler is 100% complete, dynaTmpFlushReg will no longer be needed.

unsigned __int16 dynaTmpFlushReg(unsigned char *cp,unsigned char NReg)
{
	if((NReg==0xff)||(dynaMapToMips[NReg].Reg==0xff))
	{
		unsigned __int32 stop=1;
		return(0);
	}
	unsigned __int16 l=STORE_REG(cp,dynaMapToMips[NReg].Reg,NReg);		

	// store the Native register in Mips register memory

	dynaMapToNative[dynaMapToMips[NReg].Reg].Reg=0xff;
	dynaMapToMips[NReg].Reg=0xff;
	return(l);
}

unsigned __int16 dynaTmpFlushSgnReg(unsigned char *cp,unsigned char NReg)
{
	if((NReg==0xff)||(dynaMapToMips[NReg].Reg==0xff))
	{
		unsigned __int32 stop=1;
		return(0);
	}
	unsigned __int16 l=STORE_sREG(cp,dynaMapToMips[NReg].Reg,NReg);		

	// store the Native register in Mips register memory

	dynaMapToNative[dynaMapToMips[NReg].Reg].Reg=0xff;
	dynaMapToMips[NReg].Reg=0xff;
	return(l);
}

unsigned __int16 dynaTmpFlushRegPair(unsigned char *cp,unsigned char MipsReg)
{
	unsigned __int16 l=0;
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,MipsReg*8);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_3,MipsReg*8+4);
	return(l);
}

void dynaSwitchMap(unsigned char a,unsigned char b)
{
	if((a==0xff)||(b==0xff))
	{
		unsigned __int32 stop=1;
		return;
	}
	dynaMapToNative[a].Reg=dynaMapToNative[b].Reg;
	dynaMapToMips[dynaMapToNative[a].Reg].Reg=a;
	dynaMarkRegDirty(a,true);
	// mark the registers dirty

	if(a!=b)
		dynaMapToNative[b].Reg=0xff;
}

unsigned __int16 dynaMakeFreeReg(unsigned char *cp,unsigned char *NReg)
{
	return(0);

	// first try and see if a mapped register can be freed
	unsigned __int32 BirthDate=0xffffffff;
	unsigned char Oldest=0;
	for(unsigned char i=0;i<NATIVE_REGS;i++)
	{
		if(dynaMapToMips[i].Dirty==false)		// must have been temporary, ok to use it
		{
			*NReg=i;
			return(0);
		}
		if(!dynaIsUsed(dynaMapToMips[i].Reg))
		{
			*NReg=i;
			return(0);		// no code needed, we found a mapped register that will not be used again
		}
		if(dynaMapToMips[i].BirthDate<BirthDate)
		{
			Oldest=i;
			BirthDate=dynaMapToMips[i].BirthDate;
		}
	}
	// kick the oldest register in the map, ie; the one with the earliest birthdate
	*NReg=Oldest;
	return(dynaFlushReg(cp,*NReg));
}

void dynaResetCompiler()
{
	dynaInBranch=false;
	for(unsigned char i=0;i<NATIVE_REGS;i++)
	{
		dynaMapToMips[i].Reg=0xff;
		dynaMapToMips[i].Dirty=false;
	}

	for(i=0;i<32;i++)
	{
		dynaMapToNative[i].Reg=0xff;
		dynaMapToNative[i].Dirty=false;
	}
	dynaNumFreeRegs=NATIVE_REGS;
}


unsigned __int16 dynaLoadReg(unsigned char *cp,unsigned char MipsReg)
{
	unsigned char NReg;
	unsigned __int16 l=0;
/*
	if(dynaMapToNative[MipsReg].Reg!=0xff)						// register is already mapped, so we are free to use it.
	{
		NReg=dynaMapToNative[MipsReg].Reg;
		dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;	// set birthdate of register
		dynaMapToMips[NReg].BirthDate=dynaBirthYear;		// set birthdate of register
		dynaMarkRegDirty(MipsReg,false);					// mark the registers not dirty
		dynaBirthYear++;									// another year goes by.... ;)
		return(0);											// no code needed.
	}
	if(dynaNumFreeRegs)										// are any Native regs available?
	{
		NReg=dynaGetFreeReg();								// yes, so get which one.
		dynaNumFreeRegs--;
	}
	else
	{
		l+=dynaMakeFreeReg(cp+l,&NReg);						// free up an Native register
	}
*/
	NReg=0;
	dynaMapToNative[MipsReg].Reg=NReg;						// update register map
	dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;		// set birthdate of register
	dynaMapToMips[NReg].Reg=MipsReg;						// update register map
	dynaMapToMips[NReg].BirthDate=dynaBirthYear;			// set birthdate of register
	dynaMarkRegDirty(MipsReg,false);						// mark the registers not dirty
	dynaBirthYear++;										// another year goes by.... ;)
	l+=LOAD_REG(cp+l,MipsReg,NReg);							// create code to load this register
	return(l);
}

// for the Intel, this will force EAX and EDX to be flushed (if needed) and loaded with a unsigned __int64

unsigned __int16 dynaLoadRegPair(unsigned char *cp,unsigned char MipsReg)
{
	unsigned char NReg;
	unsigned __int16 l=0;
/*
	if(dynaMapToNative[MipsReg].Reg!=0xff)						// register is already mapped, so we are free to use it.
	{
		NReg=dynaMapToNative[MipsReg].Reg;
		dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;	// set birthdate of register
		dynaMapToMips[NReg].BirthDate=dynaBirthYear;		// set birthdate of register
		dynaMarkRegDirty(MipsReg,false);					// mark the registers not dirty
		dynaBirthYear++;									// another year goes by.... ;)
		return(0);											// no code needed.
	}
	if(dynaNumFreeRegs)										// are any Native regs available?
	{
		NReg=dynaGetFreeReg();								// yes, so get which one.
		dynaNumFreeRegs--;
	}
	else
	{
		l+=dynaMakeFreeReg(cp+l,&NReg);						// free up an Native register
	}
*/
	NReg=0;
	dynaMapToNative[MipsReg].Reg=NReg;						// update register map
	dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;		// set birthdate of register
	dynaMapToMips[NReg].Reg=MipsReg;						// update register map
	dynaMapToMips[NReg].BirthDate=dynaBirthYear;			// set birthdate of register
	dynaMarkRegDirty(MipsReg,false);						// mark the registers not dirty
	dynaBirthYear++;										// another year goes by.... ;)
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,MipsReg*8);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_3,MipsReg*8+4);
	return(l);
}


unsigned __int16 dynaLoadRegForceNot(unsigned char *cp,unsigned char MipsReg,unsigned char ExcludedNativeReg)
{
	unsigned char NReg;
	unsigned __int16 l=0;
/*
	if(dynaMapToNative[MipsReg].Reg!=0xff)						// register is already mapped, so we are free to use it.
	{
		if(dynaMapToNative[MipsReg].Reg!=ExcludedNativeReg)
		{
			NReg=dynaMapToNative[MipsReg].Reg;
			dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;	// set birthdate of register
			dynaMapToMips[NReg].BirthDate=dynaBirthYear;		// set birthdate of register
			dynaMarkRegDirty(MipsReg,false);					// mark the registers not dirty
			dynaBirthYear++;									// another year goes by.... ;)
			return(0);											// no code needed.
		}
	}
	if(dynaMapToMips[ExcludedNativeReg].Reg!=0xff)
	{
		l+=dynaFlushReg(cp+l,ExcludedNativeReg);
	}
*/
	NReg=ExcludedNativeReg;
	if(NReg!=0) NReg--;
	else NReg++;			// pick a reg on either side
/*
	if(dynaMapToMips[NReg].Reg!=0xff)
	{
		l+=dynaFlushReg(cp+l,NReg);
	}
*/
	dynaMapToNative[MipsReg].Reg=NReg;						// update register map
	dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;		// set birthdate of register
	dynaMapToMips[NReg].Reg=MipsReg;						// update register map
	dynaMapToMips[NReg].BirthDate=dynaBirthYear;			// set birthdate of register
	dynaMarkRegDirty(MipsReg,false);						// mark the registers not dirty
	dynaBirthYear++;										// another year goes by.... ;)
	l+=LOAD_REG(cp+l,MipsReg,NReg);						// create code to load this register
	return(l);
}


unsigned __int16 dynaLoadRegForce(unsigned char *cp,unsigned char MipsReg,unsigned char ForcedNativeReg)
{
	unsigned char NReg;
	unsigned __int16 l=0;
/*
	if(dynaMapToNative[MipsReg].Reg!=0xff)						// register is already mapped, so we are free to use it.
	{
		if(dynaMapToNative[MipsReg].Reg==ForcedNativeReg)		// amazingly, this registers is already mapped correctly
		{
			NReg=dynaMapToNative[MipsReg].Reg;
			dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;	// set birthdate of register
			dynaMapToMips[NReg].BirthDate=dynaBirthYear;		// set birthdate of register
			dynaMarkRegDirty(MipsReg,false);					// mark the registers not dirty
			dynaBirthYear++;									// another year goes by.... ;)
			return(0);											// no code needed.
		}
	}
	if(dynaMapToMips[ForcedNativeReg].Reg!=0xff)
	{
		l+=dynaFlushReg(cp+l,ForcedNativeReg);
	}
*/
	NReg=ForcedNativeReg;
	dynaMapToNative[MipsReg].Reg=NReg;						// update register map
	dynaMapToNative[MipsReg].BirthDate=dynaBirthYear;		// set birthdate of register
	dynaMapToMips[NReg].Reg=MipsReg;						// update register map
	dynaMapToMips[NReg].BirthDate=dynaBirthYear;			// set birthdate of register
	dynaMarkRegDirty(MipsReg,false);						// mark the registers not dirty
	dynaBirthYear++;										// another year goes by.... ;)
/*
*/
	l+=LOAD_REG(cp+l,MipsReg,NReg);						// create code to load this register
	return(l);
}

unsigned __int16 dynaOpAddEqualI(unsigned char *cp,unsigned char MipsReg,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=ADD_REG_IMM(cp+l,dynaMapToNative[MipsReg].Reg,Immediate);
	dynaMarkRegDirty(MipsReg,true);					// mark the registers dirty
	return(l);
}

void Sneeky()
{
	unsigned __int32 hehe;
	hehe=1;
}

unsigned __int16 dynaNOP(unsigned char *cp)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);
	l+=NOP(cp+l);
	return(l);
}

unsigned __int32 dynaOpCode;
unsigned __int32 dynaNextOpCode;
unsigned __int32 dynaPreCompileLength;
unsigned char *dynaCompileTargetPtr;
unsigned __int32 *dynaRam;					//source for what we are compiling, must be global so that branch ops can get next instruction
unsigned __int16 dynaSrc;
unsigned __int32 dynaRegPtr;				// this points to a data structure that contains the GPR,CPR,CCR,PC etc. for the 4300
unsigned __int32 dynaPCPtr;
unsigned __int32 dynaCurPage;
unsigned char dynaForceFallOut;
unsigned __int32 dynaLengthTable[PAGE_SIZE];
unsigned char *dynaRamPtr;

typedef struct page_table
{
	unsigned char *Offset[PAGE_SIZE];
	unsigned __int32 Value[PAGE_SIZE];
} dynaPageTableStruct;

dynaPageTableStruct dynaPageTable[NUM_PAGES];		// 256 pages, 4096 unsigned __int32 ptrs per page, ie; 16K per page * 256 pages = 4MB

void dynaInit()
{
	for(int p=0;p<NUM_PAGES;p++)
	{
		for(int o=0;o<PAGE_SIZE;o++)
		{
			dynaPageTable[p].Offset[o]=NULL;				// not mapped, allocated or compiled
		}
	}
	dynaForceFallOut=false;
	SneekyAddress=(unsigned __int32)Sneeky;
	dynaCheckIntsAddress=(unsigned __int32) dynaCheckInts;
}

void dynaInvalidate(unsigned __int32 Start,unsigned __int32 Length)
{
//	return;
	unsigned __int32 Page;
	unsigned __int32 Address=Start;
	while(Address<(Start+Length))			// plus a little extra... ;)
	{
		Page=(Address&0x003fc000)>>14;
		SafeFree(dynaPageTable[Page].Offset[0]);
		for(int o=0;o<PAGE_SIZE;o++)
		{
			dynaPageTable[Page].Offset[o]=NULL;				// not mapped, allocated or compiled
		}
		Address+=(PAGE_SIZE*4);
	}
}

void dynaDestroy()
{
	for(int p=0;p<NUM_PAGES;p++)
	{
		SafeFree(dynaPageTable[p].Offset[0]);			// the zero offset of each page is the allocated memory
	}
}


unsigned char dynaPreCompilePage(unsigned __int32 Address)
{
	unsigned __int32 Page;

	dynaResetCompiler();

	Page=(Address&0x003fc000)>>14;

	unsigned __int16 len;
	unsigned char TmpWorkSpace[4096];

	dynaRam=(unsigned __int32 *)&dynaRamPtr[Address&0x003fc000];

	dynaCompileTargetPtr=TmpWorkSpace;	// this is where the compiled code goes
										// it is up to us to advance this pointer
										// note, that during the PreCompile stage, 
										// we don't advance the pointer as we are 
										// primarily building the BranchTable

	dynaPreCompileLength=0;
	unsigned __int32 *btable=dynaLengthTable;
	dynaForceFallOut=false;

	dynaCurPage=Page;
	dynaSrc=0;
	dynaPC=Address&0x003fc000;
//	dynaPC|=0x80000000;
	while(dynaSrc<PAGE_SIZE)
	{
		if(dynaSrc==0x2ee)
			unsigned __int32 S=1;
		dynaOpCode=*(dynaRam++);
		dynaNextOpCode=*dynaRam;
		if(dynaForceFallOut)
		{
			len=MainInstruction[dynaOpCode>>26](dynaCompileTargetPtr);
			len+=dynaFallOut(dynaCompileTargetPtr+len);
			dynaForceFallOut=false;
		}
		else
		{
			len=MainInstruction[dynaOpCode>>26](dynaCompileTargetPtr);
		}
		dynaSrc++;
		*(btable++)=dynaPreCompileLength;
		dynaPreCompileLength+=len;
		dynaPC+=4;
		if(dynaSrc==(PAGE_SIZE-1))
			dynaForceFallOut=TRUE;
	}
	return true;
}


unsigned char dynaInPage(unsigned __int32 Address)
{
	unsigned __int32 Page;
	Page=(Address&0x003fc000)>>14;
	if(Page==dynaCurPage) return true;
	else return false;
}

unsigned __int32 dynaGetCompiledAddress(unsigned __int32 NewPC)
{
	unsigned __int32 CompiledPC;
	unsigned __int32 Page;
	unsigned __int32 Offset;

	NewPC|=0x80000000;
	Page=  (NewPC&0x003fc000)>>14;
	Offset=(NewPC&0x00003ffc)>>2;
	CompiledPC=(unsigned __int32) dynaPageTable[Page].Offset[Offset];
	return(CompiledPC);
}


unsigned char dynaCompilePage(unsigned __int32 Address)
{
	unsigned __int32 Page,Offset;

	dynaResetCompiler();

	Page=(Address&0x003fc000)>>14;

	unsigned __int16 len;

	dynaRam=(unsigned __int32 *)&dynaRamPtr[Address&0x003fc000];

	if (dynaPageTable[Page].Offset[0] != NULL) free(dynaPageTable[Page].Offset[0]);
	dynaPageTable[Page].Offset[0]=(unsigned char *)malloc(dynaPreCompileLength);

	dynaCompileTargetPtr=dynaPageTable[Page].Offset[0];

	unsigned __int32 *btable=dynaLengthTable;
	dynaForceFallOut=false;

	dynaSrc=0;
	while(dynaSrc<PAGE_SIZE)
	{
		dynaPageTable[Page].Offset[dynaSrc]=dynaCompileTargetPtr+*(btable++);
		dynaSrc++;
	}

	dynaCompileTargetPtr=dynaPageTable[Page].Offset[0];
	btable=dynaLengthTable;
	dynaSrc=0;
	unsigned __int32 Used=0;
	dynaCurPage=Page;
	dynaPC=Address&0x003fc000;

//	dynaPC|=0x80000000;

	while(dynaSrc<PAGE_SIZE)
	{
		dynaOpCode=*(dynaRam++);
		dynaNextOpCode=*dynaRam;
		if((dynaPC&0xfffff)==0xa68)
			unsigned __int32 S=1;
		Page=  (dynaPC&0x003fc000)>>14;
		Offset=(dynaPC&0x00003ffc)>>2;
		unsigned char *test= dynaPageTable[Page].Offset[Offset];
		if((dynaPC&0xfffff)==0xa6c)
		{
			dynaHold=dynaPageTable[Page].Offset[Offset];
		}
		if(test!=dynaCompileTargetPtr)
			unsigned __int32 asddf=1;
		dynaPageTable[Page].Value[Offset]=dynaOpCode;
		if(dynaForceFallOut)
		{
			len=MainInstruction[dynaOpCode>>26](dynaCompileTargetPtr);
			len+=dynaFallOut(dynaCompileTargetPtr+len);
			dynaForceFallOut=false;
		}
		else
		{
			len=MainInstruction[dynaOpCode>>26](dynaCompileTargetPtr);
		}
		if(dynaPageTable[Page].Offset[dynaSrc]!=dynaCompileTargetPtr)
			unsigned __int32 crap=1;
		Page=  (dynaPC&0x003fc000)>>14;
		Offset=(dynaPC&0x00003ffc)>>2;
		test= dynaPageTable[Page].Offset[Offset];
		if(test!=dynaCompileTargetPtr)
			unsigned __int32 asdf=1;
		dynaSrc++;
		dynaCompileTargetPtr+=len;
		if(Used!=*btable)
		{
			unsigned __int32 Stop=1;
		}
		btable++;
		Used+=len;
		dynaPC+=4;
		if(dynaSrc==(PAGE_SIZE-1))
			dynaForceFallOut=TRUE;
	}
	dynaPC=0xa6c;
	Page=  (dynaPC&0x003fc000)>>14;
	Offset=(dynaPC&0x00003ffc)>>2;
	unsigned char *test= dynaPageTable[Page].Offset[Offset];
	if(test!=dynaHold)
		unsigned __int32 stop=1;
	return true;
}
typedef void (*funcptr)(void);
funcptr dynaStart;
/*
unsigned __int16 dynaCallInterpHelper(unsigned char *cp,unsigned __int32 code)
{
	unsigned __int16 len=0;

//#ifdef UseNew
	if (UseNew)
	{
	len+=ADD_REG_IMM(cp+len,PC_PTR,4);
	len+=STORE_REG(cp+len,242,PC_PTR);
	}
//else
	else
	{
	len+=STORE_DWORD_TO_RBANK(cp+len,dynaPC,242*8);
	}
//#endif

	len+=PUSH_ALL(cp+len);
	len+=PUSH_DWORD(cp+len,code);
	len+=LOAD_REG_DWORD(cp+len,NATIVE_0,(unsigned char *)&InterpHelperAddress);
	len+=CALL_REGISTER(cp+len,NATIVE_0);
	len+=POP_REGISTER(cp+len,NATIVE_1);
	len+=POP_ALL(cp+len);
	len+=LOAD_REG(cp+len,242,PC_PTR);

	return(len);
}

unsigned __int16 dynaFallOut(unsigned char *cp)
{
	unsigned __int16 len=0;
//#ifdef UseNew
	if (UseNew)
	len+=STORE_REG(cp+len,242,PC_PTR);
//#else
	else
	len=STORE_DWORD_TO_RBANK(cp,dynaPC+4,242*8);
//#endif
//	len+=STORE_DWORD_TO_RBANK(cp+len,dynaICount,ICOUNT);
	cp+=len;
	*(cp++)=0xc3;	//ret
	len++;
	return(len);
}
*/
WORD dynaCallInterpHelper(BYTE *cp,DWORD code)
{
	WORD len=0;

	len+=ADD_REG_IMM(cp+len,PC_PTR,4);
	len+=STORE_REG(cp+len,242,PC_PTR);
	len+=PUSH_ALL(cp+len);
	len+=PUSH_DWORD(cp+len,code);
	len+=LOAD_REG_DWORD(cp+len,NATIVE_0,(BYTE *)&InterpHelperAddress);
	len+=CALL_REGISTER(cp+len,NATIVE_0);
	len+=POP_REGISTER(cp+len,NATIVE_1);
	len+=POP_ALL(cp+len);
	len+=LOAD_REG(cp+len,242,PC_PTR);

	return(len);
}

unsigned __int16 dynaFallOut(BYTE *cp)
{
	WORD len=0;
	len+=STORE_REG(cp+len,242,PC_PTR);
	cp+=len;
	*(cp++)=0xc3;	//ret
	len++;
	return(len);
}

#include "dynaFP.h"		// floating point routines
#include "dynaMemory.h" // memory routines
#include "dynaGeneral.h" // general routines
#include "dynaBranch.h" // branch instructions
#include "dynaBranchSP.h" // 'Same Page' branch instructions
#include "dynaFastMem.h" // fast memory routines; include TLB support


unsigned char dynaExecute(unsigned __int32 Address)
{
//	return false;
	unsigned __int32 Page;
	unsigned __int32 Offset;
	unsigned char Done=false;

	while(!Done)
	{
		dynaCheckInts();
		Address=m_Reg->PC;
		if(Address==0x80000180) return false;

		Page=  (Address&0x003fc000)>>14;
		Offset=(Address&0x00003ffc)>>2;
		dynaPC=Address;
		dynaOpCode=*(unsigned __int32 *)&dynaRamPtr[Address&0x3fffff];
//		if(dynaPageTable[Page].Offset[Offset]!=NULL)			// page is allocated and compiled
		if((dynaPageTable[Page].Offset[Offset]!=NULL)&&			// page is allocated and compiled
			(dynaPageTable[Page].Value[Offset]==dynaOpCode))
		{
			dynaStart=(funcptr)dynaPageTable[Page].Offset[Offset];
			_asm
			{
				pushad
				mov	ebp,dword ptr dynaRegPtr
				mov edi,dword ptr [ebp+1936]
			}
			dynaStart();
			_asm
			{
	//			mov dword ptr [ebp+1936],edi
				popad
			}
			return true;
		}
		else
		{
			dynaPreCompilePage(Address);					// page is not allocated or compiled
			dynaCompilePage(Address);						// compile it
			Page=  (Address&0x003fc000)>>14;
			Offset=(Address&0x00003ffc)>>2;
			if(dynaPageTable[Page].Offset[Offset]!=NULL)		// try again...
			{
				dynaStart=(funcptr)dynaPageTable[Page].Offset[Offset];
				_asm
				{
					pushad
					mov	ebp,dword ptr dynaRegPtr
					mov edi,dword ptr [ebp+1936]
				}
				dynaStart();
				_asm
				{
	//				mov dword ptr [ebp+1936],edi
					popad
				}
				return true;
			}
			//screw it
			return false;								// something didn't work, let interp code handle it
		}
	}
	return true;
}



unsigned __int16 dynaCompile_sra(unsigned char *cp)
{
	return(dynaOpSra(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_sll(unsigned char *cp)
{
	if((MAKE_RD==0)&&(MAKE_RT==0)&&(MAKE_SA==0))
	{
		return(dynaNOP(cp));
	}
	return(dynaOpSll(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_reserved(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_srl(unsigned char *cp)
{
	return(dynaOpSrl(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_sllv(unsigned char *cp)
{
	unsigned __int16 len=0;
	len+=dynaOpSllV(cp+len,MAKE_RD,MAKE_RT,MAKE_RS);
	return(len);
}

unsigned __int16 dynaCompile_srlv(unsigned char *cp)
{
	unsigned __int16 len=0;
	len+=dynaOpSrlV(cp+len,MAKE_RD,MAKE_RT,MAKE_RS);
	return(len);
}

unsigned __int16 dynaCompile_srav(unsigned char *cp)
{
	unsigned __int16 len=0;
	len+=dynaOpSraV(cp+len,MAKE_RD,MAKE_RT,MAKE_RS);
	return(len);
}

unsigned __int16 dynaCompile_syscall(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_Break(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_sync(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_mfhi(unsigned char *cp)
{
	return(dynaOpMfHi(cp,MAKE_RD));
}

unsigned __int16 dynaCompile_mthi(unsigned char *cp)
{
	return(dynaOpMtHi(cp,MAKE_RD));
}

unsigned __int16 dynaCompile_mflo(unsigned char *cp)
{
	return(dynaOpMfLo(cp,MAKE_RD));
}

unsigned __int16 dynaCompile_mtlo(unsigned char *cp)
{
	return(dynaOpMtLo(cp,MAKE_RD));
}

unsigned __int16 dynaCompile_dsllv(unsigned char *cp)
{
	return(dynaOpDSllV(cp,MAKE_RD,MAKE_RT,MAKE_RS));
}

unsigned __int16 dynaCompile_dsrlv(unsigned char *cp)
{
	return(dynaOpDSrlV(cp,MAKE_RD,MAKE_RT,MAKE_RS));
}

unsigned __int16 dynaCompile_dsrav(unsigned char *cp)
{
	return(dynaOpDSraV(cp,MAKE_RD,MAKE_RT,MAKE_RS));
}

unsigned __int16 dynaCompile_mult(unsigned char *cp)
{
	return(dynaOpMult(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_multu(unsigned char *cp)
{
	return(dynaOpMultU(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_div(unsigned char *cp)
{
	return(dynaOpDiv(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_divu(unsigned char *cp)
{
	return(dynaOpDivU(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_dmult(unsigned char *cp)
{
	return(dynaOpDMult(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_dmultu(unsigned char *cp)
{
	return(dynaOpDMultU(cp,MAKE_RS,MAKE_RT));
}

// MArio doesnt work
unsigned __int16 dynaCompile_ddiv(unsigned char *cp)
{
	return(dynaOpDDiv(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_ddivu(unsigned char *cp)
{
	return(dynaOpDDivU(cp,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_add(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpRegMove(cp,MAKE_RD,MAKE_RT));
	}
	if(MAKE_RT==0)
	{
		return(dynaOpRegMove(cp,MAKE_RD,MAKE_RS));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpAddEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpAdd(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_addu(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpRegMove(cp,MAKE_RD,MAKE_RT));
	}
	if(MAKE_RT==0)
	{
		return(dynaOpRegMove(cp,MAKE_RD,MAKE_RS));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpAddEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpAdd(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_sub(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RT==0)
	{
		return(dynaOpRegMove(cp,MAKE_RD,MAKE_RS));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpSubEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpSub(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_subu(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RT==0)
	{
		return(dynaOpRegMove(cp,MAKE_RD,MAKE_RS));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpSubEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpSub(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_and(unsigned char *cp)
{
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpAndEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpAnd(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_or(unsigned char *cp)
{
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpOrEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpOr(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_xor(unsigned char *cp)
{
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpXorEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpXor(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_nor(unsigned char *cp)
{
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpNorEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpNor(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_slt(unsigned char *cp)
{
	return(dynaOpSlt(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_sltu(unsigned char *cp)
{
	return(dynaOpSltU(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_dadd(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpRegDMove(cp,MAKE_RD,MAKE_RT));
	}
	if(MAKE_RT==0)
	{
		return(dynaOpRegDMove(cp,MAKE_RD,MAKE_RS));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpDAddEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpDAdd(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_daddu(unsigned char *cp)
{

#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpRegDMove(cp,MAKE_RD,MAKE_RT));
	}
	if(MAKE_RT==0)
	{
		return(dynaOpRegDMove(cp,MAKE_RD,MAKE_RS));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpDAddEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpDAdd(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_dsub(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpRegDMove(cp,MAKE_RD,MAKE_RT));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpDSubEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpDSub(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_dsubu(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpRegDMove(cp,MAKE_RD,MAKE_RT));
	}
#endif
	if(MAKE_RD==MAKE_RS)
	{
		return(dyanOpDSubEqual(cp,MAKE_RD,MAKE_RT));
	}
	return(dyanOpDSub(cp,MAKE_RD,MAKE_RS,MAKE_RT));
}

unsigned __int16 dynaCompile_tge(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tgeu(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tlt(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tltu(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_teq(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tne(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_dsll(unsigned char *cp)
{
	return(dynaOpDSll(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_dsrl(unsigned char *cp)
{
	return(dynaOpDSrl(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_dsra(unsigned char *cp)
{
	return(dynaOpDSra(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_dsll32(unsigned char *cp)
{
	return(dynaOpDSll32(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_dsrl32(unsigned char *cp)
{
	return(dynaOpDSrl32(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_dsra32(unsigned char *cp)
{
	return(dynaOpDSra32(cp,MAKE_RD,MAKE_RT,MAKE_SA));
}

unsigned __int16 dynaCompile_special(unsigned char *cp)
{
	return(SpecialInstruction[dynaOpCode&0x3f](cp));
}

unsigned __int16 dynaCompile_regimm(unsigned char *cp)
{
	return(RegimmInstruction[(dynaOpCode>>16)&0x1f](cp));
}

unsigned __int16 dynaCompile_addi(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpLoadI(cp,MAKE_RT,MAKE_I));
	}
#endif
	if(MAKE_RT==MAKE_RS)
	{
		return(dynaOpAddIEqual(cp,MAKE_RT,MAKE_I));
	}
	if(MAKE_I==0)
	{
		return(dyanOpAddEqual(cp,MAKE_RT,MAKE_RS));
	}
	return(dynaOpAddI(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_addiu(unsigned char *cp)
{
#ifdef GPR0_OPTIMIZATION
	if(MAKE_RS==0)
	{
		return(dynaOpLoadI(cp,MAKE_RT,MAKE_I));
	}
#endif
	if(MAKE_RT==MAKE_RS)
	{
		return(dynaOpAddIEqual(cp,MAKE_RT,MAKE_I));
	}
	if(MAKE_I==0)
	{
		return(dyanOpAddEqual(cp,MAKE_RT,MAKE_RS));
	}
	return(dynaOpAddI(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_slti(unsigned char *cp)
{
	return(dynaOpSltI(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sltiu(unsigned char *cp)
{
	return(dynaOpSltIU(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_andi(unsigned char *cp)
{
	if(MAKE_RT==MAKE_RS)
	{
		return(dyanOpAndIEqual(cp,MAKE_RT,MAKE_IU));
	}
	return(dyanOpAndI(cp,MAKE_RT,MAKE_RS,MAKE_IU));
}

unsigned __int16 dynaCompile_ori(unsigned char *cp)
{
	if(MAKE_RT==MAKE_RS)
	{
		return(dyanOpOrIEqual(cp,MAKE_RT,MAKE_IU));
	}
	return(dyanOpOrI(cp,MAKE_RT,MAKE_RS,MAKE_IU));
}

unsigned __int16 dynaCompile_xori(unsigned char *cp)
{
	if(MAKE_RT==MAKE_RS)
	{
		return(dyanOpXorIEqual(cp,MAKE_RT,MAKE_IU));
	}
	return(dyanOpXorI(cp,MAKE_RT,MAKE_RS,MAKE_IU));
}

unsigned __int16 dynaCompile_lui(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpLui(cp,MAKE_RT,MAKE_I));
}

unsigned __int16 dynaCompile_cop0(unsigned char *cp)
{
	return(Cop0RSInstruction[(dynaOpCode>>21)&0x1f](cp));
}

unsigned __int16 dynaCompile_cop1(unsigned char *cp)
{
	return(Cop1RSInstruction[(dynaOpCode>>21)&0x1f](cp));
}

unsigned __int16 dynaCompile_cop2(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_daddi(unsigned char *cp)
{
	return(dynaOpDAddI(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_daddiu(unsigned char *cp)
{
	return(dynaOpDAddI(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_ldl(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLDL(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_ldr(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLDR(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lb(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLB(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lh(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLH(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lwl(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLWL(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lw(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLW(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lbu(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLBU(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lhu(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLHU(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lwr(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLWR(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lwu(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderLW(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sb(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpSb(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sh(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpSh(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_swl(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpSwl(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sw(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaCompileBuilderSW(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sdl(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpSdl(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sdr(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpSdr(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_swr(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaOpSwr(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_cache(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_ll(unsigned char *cp)
{
	return(dynaCompileBuilderLL(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lwc1(unsigned char *cp)
{
	return(dynaCompileBuilderLWC1(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lwc2(unsigned char *cp)
{
	return(dynaCompileBuilderLWC2(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_lld(unsigned char *cp)
{
	return(dynaCompileBuilderLLD(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_ldc1(unsigned char *cp)
{
	return(dynaCompileBuilderLDC1(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_ldc2(unsigned char *cp)
{
	return(dynaCompileBuilderLDC2(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_ld(unsigned char *cp)
{
	return(dynaCompileBuilderLD(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sc(unsigned char *cp)
{
	return(dynaOpSc(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_swc1(unsigned char *cp)
{
	return(dynaOpSwc1(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_swc2(unsigned char *cp)
{
	return(dynaOpSwc2(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_scd(unsigned char *cp)
{
	return(dynaOpScd(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sdc1(unsigned char *cp)
{
	return(dynaOpSdc1(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sdc2(unsigned char *cp)
{
	return(dynaOpSdc2(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_sd(unsigned char *cp)
{
	return(dynaCompileBuilderSD(cp,MAKE_RT,MAKE_RS,MAKE_I));
}

unsigned __int16 dynaCompile_tgei(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tgeiu(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tlti(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tltiu(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_teqi(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_tnei(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_rs_mf(unsigned char *cp)
{
	return(dynaOpRs0Mf(cp,MAKE_RT,MAKE_RD));
}

unsigned __int16 dynaCompile_cop0_rs_dmf(unsigned char *cp)
{
	return(dynaOpRs0DMf(cp,MAKE_RT,MAKE_RD));
}

unsigned __int16 dynaCompile_cop0_rs_cf(unsigned char *cp)
{
	return(dynaOpRs0Cf(cp,MAKE_RT,MAKE_RD));
}

unsigned __int16 dynaCompile_cop0_rs_mt(unsigned char *cp)
{
	return(dynaOpRs0Mt(cp,MAKE_RD,MAKE_RT));
}

unsigned __int16 dynaCompile_cop0_rs_dmt(unsigned char *cp)
{
	return(dynaOpRs0DMt(cp,MAKE_RD,MAKE_RT));
}

unsigned __int16 dynaCompile_cop0_rs_ct(unsigned char *cp)
{
	return(dynaOpRs0Ct(cp,MAKE_RD,MAKE_RT));
}

unsigned __int16 dynaCompile_cop0_rs_bc(unsigned char *cp)
{
	return(Cop0RTInstruction[(dynaOpCode>>16)&0x1f](cp));
}

unsigned __int16 dynaCompile_cop0_rs_co(unsigned char *cp)
{
	return(Cop0Instruction[dynaOpCode&0x3f](cp));
}

unsigned __int16 dynaCompile_cop0_rt_bcf(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_rt_bct(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_rt_bcfl(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_rt_bctl(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_tlbr(unsigned char *cp)
{
	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_tlbwi(unsigned char *cp)
{
	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_tlbwr(unsigned char *cp)
{
	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_tlbp(unsigned char *cp)
{
	return(dynaCallInterpHelper(cp,dynaOpCode));
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop0_eret(unsigned char *cp)
{
	return(dynaOpEret(cp));
}

unsigned __int16 dynaCompile_cop1_rs_mf(unsigned char *cp)
{
	return(dynaOpRs1Mf(cp,MAKE_RT,MAKE_RD));
}

unsigned __int16 dynaCompile_cop1_rs_dmf(unsigned char *cp)
{
	return(dynaOpRs1DMf(cp,MAKE_RT,MAKE_RD));
}

unsigned __int16 dynaCompile_cop1_rs_cf(unsigned char *cp)
{
	return(dynaOpRs1Cf(cp,MAKE_RT,MAKE_RD));
}

unsigned __int16 dynaCompile_cop1_rs_mt(unsigned char *cp)
{
	return(dynaOpRs1Mt(cp,MAKE_RD,MAKE_RT));
}

unsigned __int16 dynaCompile_cop1_rs_dmt(unsigned char *cp)
{
	return(dynaOpRs1DMt(cp,MAKE_RD,MAKE_RT));
}

unsigned __int16 dynaCompile_cop1_rs_ct(unsigned char *cp)
{
	return(dynaOpRs1Ct(cp,MAKE_RD,MAKE_RT));
}

unsigned __int16 dynaCompile_cop1_rs_bc(unsigned char *cp)
{
	return(Cop1RTInstruction[(dynaOpCode>>16)&0x1f](cp));
}

unsigned __int16 dynaCompile_cop1_rs_co(unsigned char *cp)
{
	return(Cop1Instruction[dynaOpCode&0x3f](cp));
}

unsigned __int16 dynaCompile_cop1_add(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPAddS(cp,MAKE_FD,MAKE_FS,MAKE_FT));
	}
	return(dynaOpFPAddD(cp,MAKE_FD,MAKE_FS,MAKE_FT));
}

unsigned __int16 dynaCompile_cop1_sub(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPSubS(cp,MAKE_FD,MAKE_FS,MAKE_FT));
	}
	return(dynaOpFPSubD(cp,MAKE_FD,MAKE_FS,MAKE_FT));
}

unsigned __int16 dynaCompile_cop1_mul(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPMulS(cp,MAKE_FD,MAKE_FS,MAKE_FT));
	}
	return(dynaOpFPMulD(cp,MAKE_FD,MAKE_FS,MAKE_FT));
}

unsigned __int16 dynaCompile_cop1_div(unsigned char *cp)
{
//	return(dynaCallInterpHelper(cp,dynaOpCode));
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPDivS(cp,MAKE_FD,MAKE_FS,MAKE_FT));
	}
	return(dynaOpFPDivD(cp,MAKE_FD,MAKE_FS,MAKE_FT));
}

unsigned __int16 dynaCompile_cop1_sqrt(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPSqrtS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPSqrtD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_abs(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPAbsS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPAbsD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_mov(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPMovS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPMovD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_neg(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPNegS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPNegD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_roundl(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPRoundLS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPRoundLD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_truncl(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPTruncLS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPTruncLD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_ceill(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPCeilLS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPCeilLD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_floorl(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPFloorLS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPFloorLD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_roundw(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPRoundWS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPRoundWD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_truncw(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPTruncWS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPTruncWD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_ceilw(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPCeilWS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPCeilWD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_floorw(unsigned char *cp)
{
	if(MAKE_FMT==FMT_S)
	{
		return(dynaOpFPFloorWS(cp,MAKE_FD,MAKE_FS));
	}
	return(dynaOpFPFloorWD(cp,MAKE_FD,MAKE_FS));
}

unsigned __int16 dynaCompile_cop1_cvts(unsigned char *cp)
{
	switch(MAKE_FMT)
	{
	case FMT_S:
		break;
	case FMT_D:
		return(dynaOpFPCvtSFromD(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_W:
		return(dynaOpFPCvtSFromW(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_L:
		return(dynaOpFPCvtSFromL(cp,MAKE_FD,MAKE_FS));
		break;
	}
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop1_cvtd(unsigned char *cp)
{
	switch(MAKE_FMT)
	{
	case FMT_S:
		return(dynaOpFPCvtDFromS(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_D:
		break;
	case FMT_W:
		return(dynaOpFPCvtDFromW(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_L:
		return(dynaOpFPCvtDFromL(cp,MAKE_FD,MAKE_FS));
		break;
	}
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop1_cvtw(unsigned char *cp)
{
	switch(MAKE_FMT)
	{
	case FMT_S:
		return(dynaOpFPCvtWFromS(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_D:
		return(dynaOpFPCvtWFromD(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_W:
		break;
	case FMT_L:
		return(dynaOpFPCvtWFromL(cp,MAKE_FD,MAKE_FS));
		break;
	}
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop1_cvtl(unsigned char *cp)
{
	switch(MAKE_FMT)
	{
	case FMT_S:
		return(dynaOpFPCvtLFromS(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_D:
		return(dynaOpFPCvtLFromD(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_W:
		return(dynaOpFPCvtLFromW(cp,MAKE_FD,MAKE_FS));
		break;
	case FMT_L:
		break;
	}
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop1_c(unsigned char *cp)
{
	switch(MAKE_FMT)
	{
	case FMT_S:   /* c.*.s */
		{
		switch(MAKE_F)
		{
		case 0x30:   /* c.f */
			return(dynaOpFPSetFalse(cp));
			break;
			
		case 0x31:   /* c.un */
			break;
			
		case 0x32:   /* c.eq */
			return(dynaOpFPEqualS(cp,MAKE_FS,MAKE_FT));
			break;
			
		case 0x33:   /* c.ueq */
			return(dynaOpFPEqualS(cp,MAKE_FS,MAKE_FT));
			break;
			
		case 0x34:   /* c.olt */
		case 0x35:   /* c.ult */
		case 0x36:   /* c.ole */
		case 0x37:   /* c.ule */
		case 0x38:   /* c.sf */
		case 0x39:   /* c.ngle */
		case 0x3a:   /* c.seq */
		case 0x3b:   /* c.ngl */
			break;
			
		case 0x3c:   /* c.lt */
			return(dynaOpFPLessThanS(cp,MAKE_FS,MAKE_FT));
			break;
			
		case 0x3d:   /* c.nge */
			return(dynaOpFPLessThanS(cp,MAKE_FS,MAKE_FT));
			break;
			
		case 0x3e:   /* c.le */
			return(dynaOpFPLessThanEqualS(cp,MAKE_FS,MAKE_FT));
			break;
			
		case 0x3f:   /* c.ngt */
			return(dynaOpFPLessThanEqualS(cp,MAKE_FS,MAKE_FT));
			break;
			
		} /* switch(__F) */
		
		break;
		}
		
		case FMT_D:   /* c.*.d */
			{
			switch(MAKE_F)
			{
			case 0x30:   /* c.f */
				return(dynaOpFPSetFalse(cp));
				break;
				
			case 0x31:   /* c.un */
				break;
				
			case 0x32:   /* c.eq */
				return(dynaOpFPEqualD(cp,MAKE_FS,MAKE_FT));
				break;
				
			case 0x33:   /* c.ueq */
				return(dynaOpFPEqualD(cp,MAKE_FS,MAKE_FT));
				break;
				
			case 0x34:   /* c.olt */
			case 0x35:   /* c.ult */
			case 0x36:   /* c.ole */
			case 0x37:   /* c.ule */
			case 0x38:   /* c.sf */
			case 0x39:   /* c.ngle */
			case 0x3a:   /* c.seq */
			case 0x3b:   /* c.ngl */
				break;
				
			case 0x3c:   /* c.lt */
				return(dynaOpFPLessThanD(cp,MAKE_FS,MAKE_FT));
				break;
				
			case 0x3d:   /* c.nge */
				return(dynaOpFPLessThanD(cp,MAKE_FS,MAKE_FT));
				break;
				
			case 0x3e:   /* c.le */
				return(dynaOpFPLessThanEqualD(cp,MAKE_FS,MAKE_FT));
				break;
				
			case 0x3f:   /* c.ngt */
				return(dynaOpFPLessThanEqualD(cp,MAKE_FS,MAKE_FT));
				break;
				
			} /* switch(__F) */
			}
				
    } /* switch(__FMT) */
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_cop2_rs_not_implemented(unsigned char *cp)
{
	return(dynaNOP(cp));
}

unsigned __int16 dynaCompile_jr(unsigned char *cp)
{
#ifdef JR
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;
	unsigned __int16 len=dynaOpJr(cp,MAKE_RS);
	dynaInBranch=false;
	return(len);

}

unsigned __int16 dynaCompile_jalr(unsigned char *cp)
{
#ifdef JALR
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

	unsigned __int16 len;
	len=dynaOpJalr(cp,MAKE_RD,MAKE_RS);
	dynaInBranch=false;
	return(len);
}


unsigned __int16 dynaCompile_j(unsigned char *cp)
{
#ifdef J
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;
	unsigned __int32 t=MAKE_T;
	if(((MAKE_T&0x3fffff)==(dynaPC&0x3fffff))) //&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_T));
	}
/*
*/

	unsigned __int16 len=dynaOpJ(cp,MAKE_T);
	dynaInBranch=false;
	return(len);

}

unsigned __int16 dynaCompile_jal(unsigned char *cp)
{
#ifdef JAL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

	unsigned __int16 len;
	len=dynaOpJal(cp,MAKE_T);
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_beq(unsigned char *cp)
{
#ifdef BEQ
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpBeqILoop(cp,MAKE_RT,MAKE_RS,MAKE_O));
	}
/*
*/

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBeqSamePage(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBeq(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bne(unsigned char *cp)
{
#ifdef BNE
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))) //&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpBneILoop(cp,MAKE_RT,MAKE_RS,MAKE_O));
	}


	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBneSamePage(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBne(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_blez(unsigned char *cp)
{
#ifdef BLEZ
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBlezSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBlez(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bgtz(unsigned char *cp)
{
#ifdef BGTZ
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBgtzSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBgtz(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_beql(unsigned char *cp)
{
#ifdef BEQL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBeqlSamePage(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBeql(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bnel(unsigned char *cp)
{
#ifdef BNEL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBnelSamePage(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBnel(cp,MAKE_RT,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_blezl(unsigned char *cp)
{
#ifdef BLEZL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBlezlSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBlezl(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bgtzl(unsigned char *cp)
{
#ifdef BGTZL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBgtzlSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBgtzl(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bltz(unsigned char *cp)
{
#ifdef BLTZ
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBltzSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBltz(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bgez(unsigned char *cp)
{
#ifdef BGEZ
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBgezSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBgez(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bltzl(unsigned char *cp)
{
#ifdef BLTZL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;


#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif
	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBltzlSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBltzl(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bgezl(unsigned char *cp)
{
#ifdef BGEZL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBgezlSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBgezl(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bltzal(unsigned char *cp)
{
#ifdef BLTZAL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBltzalSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBltzal(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bgezal(unsigned char *cp)
{
#ifdef BGEZAL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBgezalSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBgezal(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bltzall(unsigned char *cp)
{
#ifdef BLTZALL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBltzallSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBltzall(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_bgezall(unsigned char *cp)
{
#ifdef BGEZALL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBgezallSamePage(cp,MAKE_RS,MAKE_O);
	}
	else
	{
		len=dynaOpBgezall(cp,MAKE_RS,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_cop1_rt_bcf(unsigned char *cp)
{
#ifdef BCF
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;


#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif
	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBcfSamePage(cp,MAKE_O);
	}
	else
	{
		len=dynaOpBcf(cp,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_cop1_rt_bct(unsigned char *cp)
{
#ifdef BCT
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBctSamePage(cp,MAKE_O);
	}
	else
	{
		len=dynaOpBct(cp,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_cop1_rt_bcfl(unsigned char *cp)
{
#ifdef BCFL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif
	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;

#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif

	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBcflSamePage(cp,MAKE_O);
	}
	else
	{
		len=dynaOpBcfl(cp,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_cop1_rt_bctl(unsigned char *cp)
{
#ifdef BCTL
	unsigned __int16 l=0;
	l+=dynaCallInterpHelper(cp+l,dynaOpCode);
	l+=dynaFallOut(cp+l);
	return(l);
#endif

	if(dynaInBranch)
	{
		return(NOP(cp));
	}
	dynaInBranch=true;


#ifdef ALL_ILOOP
	if(((MAKE_O&0x3fffff)==(dynaPC&0x3fffff))&&(dynaNextOpCode==0))
	{
		dynaInBranch=false;
		return(dynaOpILoop(cp,MAKE_O));
	}
#endif
	unsigned __int16 len;
	if(dynaInPage(MAKE_O))
	{
		len=dynaOpBctlSamePage(cp,MAKE_O);
	}
	else
	{
		len=dynaOpBctl(cp,MAKE_O);
	}
	dynaInBranch=false;
	return(len);
}

unsigned __int16 dynaCompile_invalid(unsigned char *cp)
{
	return(NOP(cp));
}


#ifndef TRWIN
}
#endif
