#ifdef TRWIN
	#define WIDTH_MULT 2
#else
	#define WIDTH_MULT 1
#endif

void dynaHelpDMult(DWORD op0,DWORD op1)
{
	DWORD x0=m_Reg->r[op0*WIDTH_MULT];
	DWORD x1=m_Reg->r[op0*WIDTH_MULT]>>32;
	DWORD y0=m_Reg->r[op1*WIDTH_MULT];
	DWORD y1=m_Reg->r[op1*WIDTH_MULT]>>32;

	DWORD p0=0,p1=0,p2=0,p3=0;
	DWORD sign1=x1&0x80000000;
	DWORD sign2=y1&0x80000000;
	if(sign1)
	{
		QWORD tmp=((QWORD)x1<<32)+x0;
		tmp=~tmp;
		tmp++;
		x0=(DWORD)tmp;
		x1=(tmp>>32);
	}
	if(sign2)
	{
		QWORD tmp=((QWORD)y1<<32)+y0;
		tmp=~tmp;
		tmp++;
		y0=(DWORD)tmp;
		y1=(tmp>>32);
	}
	sign1^=sign2;
	_asm
	{
		mov eax,dword ptr x0
		mul dword ptr y0
		mov dword ptr p0,eax
		mov dword ptr p1,edx
		mov eax,dword ptr x0
		mul dword ptr y1
		add dword ptr p1,eax
		adc dword ptr p2,edx
		adc dword ptr p3,0
		mov eax,dword ptr x1
		mul dword ptr y0
		add dword ptr p1,eax
		adc dword ptr p2,edx
		adc dword ptr p3,0
		mov eax,dword ptr x1
		mul dword ptr y1
		add dword ptr p2,eax
		adc dword ptr p3,edx
		mov eax,dword ptr sign1
		cmp eax,0
		jz sign_ok
		not dword ptr p0
		not dword ptr p1
		not dword ptr p2
		not dword ptr p3
		add dword ptr p0,1
		adc dword ptr p1,0
		adc dword ptr p2,0
		adc dword ptr p3,0
sign_ok:
	}
	m_Reg->Lo=((QWORD)p1<<32)+(p0);
	m_Reg->Hi=((QWORD)p3<<32)+(p2);
}

void dynaHelpDMultU(DWORD op0,DWORD op1)
{
	DWORD x0=m_Reg->r[op0*WIDTH_MULT];
	DWORD x1=m_Reg->r[op0*WIDTH_MULT]>>32;
	DWORD y0=m_Reg->r[op1*WIDTH_MULT];
	DWORD y1=m_Reg->r[op1*WIDTH_MULT]>>32;
	DWORD p0,p1,p2=0,p3=0;
	_asm
	{
		mov eax,dword ptr x0
		mul dword ptr y0
		mov dword ptr p1,edx
		mov dword ptr p0,eax
		mov eax,dword ptr x0
		mul dword ptr y1
		add dword ptr p1,eax
		adc dword ptr p2,edx
		adc dword ptr p3,0
		mov eax,dword ptr x1
		mul dword ptr y0
		add dword ptr p1,eax
		adc dword ptr p2,edx
		adc dword ptr p3,0
		mov eax,dword ptr x1
		mul dword ptr y1
		add dword ptr p2,eax
		adc dword ptr p3,edx
	}
	m_Reg->Lo=((QWORD)p1<<32)+(p0);
	m_Reg->Hi=((QWORD)p3<<32)+(p2);
}

WORD dynaOpDMult(BYTE *cp,BYTE op0,BYTE op1)
{
	WORD l=0;
	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_ALL(cp+l);
	l+=PUSH_DWORD(cp+l,op1);			//base
	l+=PUSH_DWORD(cp+l,op0);			//what
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,(DWORD)dynaHelpDMult);
	l+=CALL_REGISTER(cp+l,NATIVE_0);	// the called address will return back to 'start'+0x50, which will be the
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_ALL(cp+l);
/*
	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
	l+=IMUL(cp+l,op0,op1);	// imul op1
	DWORD tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	tmp=HI;	
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_0);			// save in hi

	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);
*/
	return(l);
}

WORD dynaOpDMultU(BYTE *cp,BYTE op0,BYTE op1)
{
	WORD l=0;
	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_ALL(cp+l);
	l+=PUSH_DWORD(cp+l,op1);			//base
	l+=PUSH_DWORD(cp+l,op0);			//what
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,(DWORD)dynaHelpDMultU);
	l+=CALL_REGISTER(cp+l,NATIVE_0);	// the called address will return back to 'start'+0x50, which will be the
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_ALL(cp+l);
/*
	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
	l+=MUL(cp+l,op0,op1);	// imul op1
	DWORD tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	tmp=HI;	
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_0);			// save in hi

	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);
*/
	return(l);
}
