unsigned __int16 PUSH_STACK_POINTER(unsigned char *cp)
{
	*(cp++)=0x54;
	return(1);
}
unsigned __int16 LOAD_REG_DWORD(unsigned char *cp,unsigned char Reg,unsigned char *Address)
{
	unsigned __int16 len=0;

	*(cp++)=0xb8+Reg;		// x86 mov unsigned __int32 ptr
	len++;
	memcpy(cp,Address,4);	// unsigned __int32 to load
	len+=4;
	return(len);
}

unsigned __int16 STORE_REG_DWORD(unsigned char *cp,unsigned char Reg,unsigned char *Address)
{
	unsigned __int16 len=0;

	*(cp++)=0x89;		// x86 mov unsigned __int32 ptr
	len++;
	*(cp++)=0x05+(Reg<<3);		// x86 mov unsigned __int32 ptr
	len++;
	memcpy(cp,Address,4);	// unsigned __int32 to load
	len+=4;
	return(len);
}

unsigned __int16 CALL_REGISTER(unsigned char *cp,unsigned char Reg)
{
	unsigned __int16 len=0;

	*(cp++)=0xff;			// x86 call register
	len++;
	*(cp++)=0xd0+Reg;		// register to call
	len++;
	return(len);
}

unsigned __int16 PUSH_DWORD(unsigned char *cp,unsigned __int32 Value)
{
	unsigned __int16 len=0;

	*(cp++)=0x68;			// x86 push memory
	len++;
	memcpy(cp,&Value,4);	// unsigned __int32 to push
	len+=4;

	return(len);
}

unsigned __int16 POP_REGISTER(unsigned char *cp,unsigned char Reg)
{
	unsigned __int16 len=0;

	*(cp++)=0x58+(Reg&0xf);		// register to pop
	len++;
	return(len);
}


unsigned __int16 PUSH_REGISTER(unsigned char *cp,unsigned char Reg)
{
	unsigned __int16 len=0;

	*(cp++)=0x50+Reg;		// register to push
	len++;
	return(len);
}


unsigned __int16 STORE_REG(unsigned char *cp,unsigned __int16 MipsRegs,unsigned char NativeReg)
{
	int i,l=6;
	unsigned __int32 tmp;
	*(cp++)=0x89;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	tmp=MipsRegs*8;
	memcpy(cp,&tmp,4);
	return(l);
}

unsigned __int16 STORE_zREG(unsigned char *cp,unsigned __int16 MipsRegs,unsigned char NativeReg)
{
	int i,l=6;
	unsigned __int32 tmp;
	*(cp++)=0x89;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	tmp=MipsRegs*8;
	memcpy(cp,&tmp,4);
	cp+=4;
	*(cp++)=0x51;
	*(cp++)=0x50;
	*(cp++)=0x31;
	*(cp++)=0xc0;
	l+=4;
	*(cp++)=0x89;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	tmp+=4;
	memcpy(cp,&tmp,4);
	cp+=4;
	l+=6;
	*(cp++)=0x58;
	*(cp++)=0x59;
	l+=2;
	return(l);
}


unsigned __int16 STORE_sREG(unsigned char *cp,unsigned __int16 MipsRegs,unsigned char NativeReg)
{
	int i,l=6;
	unsigned __int32 tmp;
	*(cp++)=0x89;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	tmp=MipsRegs*8;
	memcpy(cp,&tmp,4);
	cp+=4;
	*(cp++)=0x51;
	*(cp++)=0x50;
	*(cp++)=0xb1;
	*(cp++)=0x1f;
	*(cp++)=0xd3;
	*(cp++)=0xf8;
	l+=6;
	*(cp++)=0x89;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	tmp+=4;
	memcpy(cp,&tmp,4);
	cp+=4;
	l+=6;
	*(cp++)=0x58;
	*(cp++)=0x59;
	l+=2;
	return(l);
}


unsigned __int16 STORE_REG_INDEX(unsigned char *cp,unsigned char NativeReg,unsigned __int16 Index)
{
	*(cp++)=0x89;
    *(cp++)=0xbd;
	memcpy(cp,&Index,4);

	return(6);
}

unsigned __int16 LOAD_REG(unsigned char *cp,unsigned char MipsRegs,unsigned __int16 NativeReg)
{
	*(cp++)=0x8b;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	unsigned __int32 tmp=MipsRegs*8;
	memcpy(cp,&tmp,4);
	return(6);
}


unsigned __int16 LOAD_REG_INDEX(unsigned char *cp,unsigned char NativeReg,unsigned __int16 Index)
{
	*(cp++)=0x8b;
	*(cp++)=0x40+(NativeReg<<3)+REG_PTR;
	*(cp++)=(unsigned char)Index;				//index to the desired mips register
	return(3);
}


unsigned __int16 SUB_REG_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xe8+NativeReg;
	memcpy(cp,&Immediate,4);
	return(6);
}

unsigned __int16 ADD_REG_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xc0+NativeReg;
	memcpy(cp,&Immediate,4);
	return(6);
}

unsigned __int16 ADD_REG_REG(unsigned char *cp,unsigned char NativeReg1,unsigned char NativeReg2)
{
	*(cp++)=0x01;
	*(cp++)=0xc0 | NativeReg1 | NativeReg2 << 3;
	return(2);
}

unsigned __int16 ADC_REG_REG(unsigned char *cp,unsigned char NativeReg1,unsigned char NativeReg2)
{
	*(cp++)=0x11;
	*(cp++)=0xc0 | NativeReg1 | NativeReg2 << 3;
	return(2);
}

unsigned __int16 SUB_REG_REG(unsigned char *cp,unsigned char NativeReg1,unsigned char NativeReg2)
{
	*(cp++)=0x29;
	*(cp++)=0xc0 | NativeReg1 | NativeReg2 << 3;
	return(2);
}

unsigned __int16 SBB_REG_REG(unsigned char *cp,unsigned char NativeReg1,unsigned char NativeReg2)
{
	*(cp++)=0x19;
	*(cp++)=0xc0 | NativeReg1 | NativeReg2 << 3;
	return(2);
}

unsigned __int16 ADD_REG_IMM_BYTE(unsigned char *cp,unsigned char NativeReg,unsigned char Immediate)
{
	*(cp++)=0x83;
	*(cp++)=0xc0+NativeReg;
	*(cp++)=Immediate;
	return(3);
}

unsigned __int16 ADD_REG_DWORD(unsigned char *cp,unsigned char NativeReg,unsigned char *Address)
{
	*(cp++)=0x03;
	*(cp++)=0x35;//hardcoded for esi
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 NOP(unsigned char *cp)
{
	*(cp++)=0x90;
	return(1);
}

unsigned __int16 AND_REG_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xe0+NativeReg;
	memcpy(cp,&Immediate,4);
	return(6);
}

unsigned __int16 AND_REG_IMM_BYTE(unsigned char *cp,unsigned char NativeReg,unsigned char Immediate)
{
	*(cp++)=0x83;
	*(cp++)=0xe0+NativeReg;
	*(cp++)=Immediate;
	return(3);
}

unsigned __int16 OR_REG_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xc8+NativeReg;
	memcpy(cp,&Immediate,4);
	return(6);
}

unsigned __int16 XOR_REG_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xf0+NativeReg;
	memcpy(cp,&Immediate,4);
	return(6);
}

unsigned __int16 NOT_REG(unsigned char *cp,unsigned char NativeReg)
{
	*(cp++)=0xf7;
	*(cp++)=0xd0+NativeReg;
	return(2);
}


unsigned __int16 CMP_REG_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xf8+NativeReg;
	memcpy(cp,&Immediate,4);
	return(6);
}

unsigned __int16 CMP_RBANK_WITH_IMM(unsigned char *cp,unsigned __int32 Offset,unsigned __int32 Immediate)
{
	*(cp++)=0x81;
	*(cp++)=0xbd;
	memcpy(cp,&Offset,4);
	cp+=4;
	memcpy(cp,&Immediate,4);
	return(10);
}

unsigned __int16 CMP_RBANK_WITH_IMM_BYTE(unsigned char *cp,unsigned __int32 Offset,unsigned char Immediate)
{
	*(cp++)=0x83;
	*(cp++)=0xbd;
	memcpy(cp,&Offset,4);
	cp+=4;
	*(cp++)=Immediate;
	return(7);
}

unsigned __int16 STORE_MEM_REG(unsigned char *cp,unsigned char DstRegPtr,unsigned char Reg)
{
	*(cp++)=0x89;
	*(cp++)=(Reg<<3)|(DstRegPtr);
	return(2);
}

unsigned __int16 STORE_MEM_WORD_REG(unsigned char *cp,unsigned char DstRegPtr,unsigned char Reg)
{
	*(cp++)=0x66;
	*(cp++)=0x89;
	*(cp++)=(Reg<<3)|(DstRegPtr);
	return(3);
}

unsigned __int16 STORE_MEM_BYTE_REG(unsigned char *cp,unsigned char DstRegPtr,unsigned char Reg)
{
	*(cp++)=0x88;
	*(cp++)=(Reg<<3)|(DstRegPtr);
	return(2);
}

unsigned __int16 LOAD_MEM_REG(unsigned char *cp,unsigned char DstRegPtr,unsigned char Reg)
{
	*(cp++)=0x8b;
	*(cp++)=(Reg<<3)|(DstRegPtr);
	return(2);
}

unsigned __int16 JMP_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0xeb;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JMP_LONG(unsigned char *cp,unsigned __int32 Address)
{
	unsigned __int32 Current=(unsigned __int32)cp+5;
	unsigned __int32 Offset=Address-Current;
	*(cp++)=0xe9;
	memcpy(cp,&Offset,4);
	return(5);
}

unsigned __int16 NATIVE_REG_TO_REG(unsigned char *cp,unsigned char r1,unsigned char r2)
{
	*(cp++)=0x8b;
	*(cp++)=0xc0+(r1<<3)+(r2);
	return(2);
}

unsigned __int16 ZERO_EXTEND(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
//	_asm add unsigned __int32 ptr ICount,eax
/*	*(cp++)=0xc7;
	*(cp++)=0x06;
	memcpy(cp,&Address,4);
	cp+=4;
	*(cp++)=0x00;
	*(cp++)=0x00;
	*(cp++)=0x00;
	*(cp++)=0x00;
	return(10);
*/
	*(cp++)=0xc7;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&Address,4);	// mov eax,[ebp+SrcOff]
	cp+=4;
	*(cp++)=0x00;
	*(cp++)=0x00;
	*(cp++)=0x00;
	*(cp++)=0x00;
	return(10);
}

unsigned __int16 SIGN_EXTEND(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
//	_asm add unsigned __int32 ptr ICount,eax
	*(cp++)=0x7c; // jmp neg
	*(cp++)=0x0c;

	*(cp++)=0xc7;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&Address,4);
	cp+=4;
	*(cp++)=0x00;
	*(cp++)=0x00;
	*(cp++)=0x00;
	*(cp++)=0x00;

	*(cp++)=0xeb; // jmp to end
	*(cp++)=0x0a;

	*(cp++)=0xc7;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&Address,4);
	cp+=4;
	*(cp++)=0xff;
	*(cp++)=0xff;
	*(cp++)=0xff;
	*(cp++)=0xff;

	return(24);
}

unsigned __int16 ADD_REG_TO_ABS_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
//	_asm add unsigned __int32 ptr ICount,eax
	*(cp++)=0x01;
	*(cp++)=0x05+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 ADD_REG_TO_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
//	_asm add unsigned __int32 ptr ICount,eax
	*(cp++)=0x01;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 ADD_DWORD_TO_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x03;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 INC_RBANK(unsigned char *cp,unsigned __int32 Address)
{
	*(cp++)=0xff;
	*(cp++)=0x85;
	memcpy(cp,&Address,4);
	cp+=4;
	return(6);
}

unsigned __int16 ADD_IMM_TO_RBANK_BYTE(unsigned char *cp,unsigned char Immediate,unsigned __int32 Address)
{
	*(cp++)=0x83;
	*(cp++)=0x85;
	memcpy(cp,&Address,4);
	cp+=4;
	*(cp++)=Immediate;
	return(7);
}

unsigned __int16 ADD_IMM_TO_RBANK(unsigned char *cp,unsigned __int32 Immediate,unsigned __int32 Address)
{
	*(cp++)=0x81;
	*(cp++)=0x85;
	memcpy(cp,&Address,4);
	cp+=4;
	memcpy(cp,&Immediate,4);
	return(10);
}


unsigned __int16 AND_RBANK_WITH_IMM(unsigned char *cp,unsigned __int32 Immediate,unsigned __int32 Address)
{
	*(cp++)=0x81;
	*(cp++)=0xa5;
	memcpy(cp,&Address,4);
	cp+=4;
	memcpy(cp,&Immediate,4);
	return(10);
}


unsigned __int16 OR_RBANK_WITH_REG(unsigned char *cp,unsigned char Reg,unsigned __int32 Address)
{
	*(cp++)=0x09;
	*(cp++)=0x85+(Reg<<3);
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 ZERO_EXTEND_REG(unsigned char *cp,unsigned char reg)
{
	*(cp++)=0x0f;
	*(cp++)=0xb7;
	*(cp++)=0xc0+reg;
	return(3);
}


unsigned __int16 SUB_REG_FROM_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x29;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 SUB_DWORD_FROM_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x2b;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 AND_REG_WITH_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x21;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 AND_DWORD_WITH_IMM(unsigned char *cp,unsigned __int32 Immediate,unsigned __int32 Address)
{
	*(cp++)=0x81;
	*(cp++)=0xa5;
	memcpy(cp,&Address,4);
	cp+=4;
	memcpy(cp,&Immediate,4);
	return(10);
}

unsigned __int16 OR_IMM_WITH_DWORD(unsigned char *cp,unsigned __int32 Immediate,unsigned __int32 Address)
{
	*(cp++)=0x81;
	*(cp++)=0x8d;
	memcpy(cp,&Address,4);
	cp+=4;
	memcpy(cp,&Immediate,4);
	return(10);
}

unsigned __int16 NOT_DWORD(unsigned char *cp,unsigned __int32 Address)
{
	*(cp++)=0xf7;
	*(cp++)=0x95;
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 XOR_IMM_WITH_DWORD(unsigned char *cp,unsigned __int32 Immediate,unsigned __int32 Address)
{
	*(cp++)=0x81;
	*(cp++)=0xb5;
	memcpy(cp,&Address,4);
	cp+=4;
	memcpy(cp,&Immediate,4);
	return(10);
}

unsigned __int16 CMP_DWORD_WITH_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x3b;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 AND_DWORD_WITH_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x23;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 XOR_REG_WITH_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x31;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 XOR_DWORD_WITH_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x33;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 OR_REG_WITH_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x09;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 OR_DWORD_WITH_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x0b;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}


unsigned __int16 ADC_REG_TO_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x11;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 ADC_DWORD_TO_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x13;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 SBB_REG_FROM_DWORD(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x19;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 SBB_DWORD_FROM_REG(unsigned char *cp,unsigned char r1,unsigned __int32 Address)
{
	*(cp++)=0x1b;
	*(cp++)=0x85+(r1<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 JZ_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x74;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JNZ_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x75;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JG_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x7f;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JL_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x7c;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JB_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x72;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JLE_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x7e;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JGE_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x7d;
	*(cp++)=off;
	return(2);
}


unsigned __int16 JE_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x74;
	*(cp++)=off;
	return(2);
}


unsigned __int16 JNE_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x75;
	*(cp++)=off;
	return(2);
}

unsigned __int16 JAE_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x73;
	*(cp++)=off;
	return(2);
}


unsigned __int16 JBE_SHORT(unsigned char *cp,unsigned char off)
{
	*(cp++)=0x76;
	*(cp++)=off;
	return(2);
}

unsigned __int16 PUSH_ALL(unsigned char *cp)
{
	*(cp++)=0x60;
	return(1);
}

unsigned __int16 POP_ALL(unsigned char *cp)
{
	*(cp++)=0x61;
	return(1);
}

unsigned __int16 ZERO_REG(unsigned char *cp,unsigned char NativeReg)
{
	// xor NativeReg,NativeReg
	*(cp++)=0x33;
	*(cp++)=0xc0+(NativeReg<<3)+NativeReg;
	return(2);
}

unsigned __int16 REG_COMPARE_IMM(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Immediate)
{
	// cmp NativeReg,Immediate
	*(cp++)=0x3d;
	memcpy(cp,&Immediate,4);
	return(5);
}

unsigned __int16 PREDICT_REG_INC(unsigned char *cp,unsigned char NativeReg)
{
	return(2);
}

unsigned __int16 JGE_RELATIVE(unsigned char *cp,unsigned __int32 Offset)
{
	// jge offset
	return(6);
}

unsigned __int16 REG_INC(unsigned char *cp,unsigned char NativeReg)
{
	// inc NativeReg
	return(2);
}


unsigned __int16 ADD_MEMORY_INDEXED(unsigned char *cp,unsigned char *address,unsigned __int16 Index)
{
	unsigned __int32 value=*(unsigned __int32 *)address;
	value+=Index;
	*(cp++)=0x83;
	*(cp++)=0x05;
	memcpy(cp,&value,4);
	cp+=4;
	*(cp++)=0x4;
	return(7);
}

unsigned __int16 SRA_REG_IMM(unsigned char *cp,unsigned char Reg,unsigned __int32 Immediate)
{
	*(cp++)=0xc1;
	*(cp++)=0xf8+Reg;
	*(cp++)=(unsigned char)Immediate;
	return(3);
}

unsigned __int16 SRL_REG_IMM(unsigned char *cp,unsigned char Reg,unsigned __int32 Immediate)
{
	*(cp++)=0xc1;
	*(cp++)=0xe8+Reg;
	*(cp++)=(unsigned char)Immediate;
	return(3);
}

unsigned __int16 SLL_REG_IMM(unsigned char *cp,unsigned char Reg,unsigned __int32 Immediate)
{
	*(cp++)=0xc1;
	*(cp++)=0xe0+Reg;
	*(cp++)=(unsigned char)Immediate;
	return(3);
}

unsigned __int16 SHLD_REG_IMM(unsigned char *cp,unsigned char Immediate)
{
	*(cp++)=0x0f;
	*(cp++)=0xa4;
	*(cp++)=0xc2;
	*(cp++)=Immediate;
	return(4);
}

unsigned __int16 SHLD_REG_REG(unsigned char *cp)
{
	*(cp++)=0x0f;
	*(cp++)=0xa5;
	*(cp++)=0xc2;
	return(3);
}


unsigned __int16 SHRD_REG_IMM(unsigned char *cp,unsigned char Immediate)
{
	*(cp++)=0x0f;
	*(cp++)=0xac;
	*(cp++)=0xc2;
	*(cp++)=Immediate;
	return(4);
}

unsigned __int16 SHRD_REG_REG(unsigned char *cp)
{
	*(cp++)=0x0f;
	*(cp++)=0xad;
	*(cp++)=0xc2;
	return(3);
}


unsigned __int16 SRA_REG_REG(unsigned char *cp,unsigned char Reg,unsigned char ShiftReg)
{
	*(cp++)=0xd3;
	*(cp++)=0xf8;
	return(2);
}


unsigned __int16 SUB_NATIVE_REG_REG(unsigned char *cp,unsigned char r1,unsigned char r2)
{
	*(cp++)=0x2b;
	*(cp++)=0xc0+(r1<<3)+r2;
	return(2);
}

unsigned __int16 SRL_REG_REG(unsigned char *cp,unsigned char Reg,unsigned __int32 Immediate)
{
	*(cp++)=0xd3;
	*(cp++)=0xe8;
	return(2);
}

unsigned __int16 SLL_REG_REG(unsigned char *cp,unsigned char Reg,unsigned __int32 Immediate)
{
	*(cp++)=0xd3;
	*(cp++)=0xe0;
	return(2);
}

unsigned __int16 REG_TO_REG(unsigned char *cp,unsigned char MipsDst,unsigned char MipsSrc)
{
	return(0);
}

unsigned __int16 LOAD_REG_FROM_RBANK(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Offset)
{
	*(cp++)=0x8b;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	memcpy(cp,&Offset,4);	// mov eax,[ebp+SrcOff]
	return(6);
}

unsigned __int16 STORE_REG_TO_RBANK(unsigned char *cp,unsigned char NativeReg,unsigned __int32 Offset)
{
	*(cp++)=0x89;
	*(cp++)=0x80+(NativeReg<<3)+REG_PTR;
	memcpy(cp,&Offset,4);	// mov eax,[ebp+SrcOff]
	return(6);
}

unsigned __int16 STORE_DWORD_TO_RBANK(unsigned char *cp,unsigned __int32 Value,unsigned __int32 Offset)
{
	*(cp++)=0xc7;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&Offset,4);	// mov eax,[ebp+SrcOff]
	cp+=4;
	memcpy(cp,&Value,4);	// mov eax,[ebp+SrcOff]
	return(10);
}

unsigned __int16 MEM_TO_MEM_QWORD(unsigned char *cp,unsigned __int32 DstOff,unsigned __int32 SrcOff)
{
	*(cp++)=0x50;			// push eax

	*(cp++)=0x8b;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&SrcOff,4);	// mov eax,[ebp+SrcOff]
	cp+=4;

	*(cp++)=0x89;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&DstOff,4);	// move [ebp+DstOff],eax
	cp+=4;
	SrcOff+=4;
	DstOff+=4;

	*(cp++)=0x8b;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&SrcOff,4);	// mov eax,[ebp+SrcOff+4]
	cp+=4;

	*(cp++)=0x89;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&DstOff,4);	// move [ebp+DstOff+4],eax
	cp+=4;
	
	*(cp++)=0x58;			// pop eax

	return(26);
}

unsigned __int16 MEM_TO_MEM_DWORD(unsigned char *cp,unsigned __int32 DstOff,unsigned __int32 SrcOff)
{
	*(cp++)=0x50;			// push eax

	*(cp++)=0x8b;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&SrcOff,4);	// mov eax,[ebp+SrcOff]
	cp+=4;

	*(cp++)=0x89;
	*(cp++)=0x80+REG_PTR;
	memcpy(cp,&DstOff,4);	// move [ebp+DstOff],eax
	cp+=4;
	
	*(cp++)=0x58;			// pop eax

	return(14);
}

unsigned __int16 IMUL(unsigned char *cp,unsigned char op0,unsigned char op1)		// op0 is ignored
{
	unsigned __int32 tmp=op1*8;
	*(cp++)=0xf7;
	*(cp++)=0xad;
	memcpy(cp,&tmp,4);		// imul unsigned __int32 ptr [ebp+Op1*8]
	return(6);
}

unsigned __int16 MUL(unsigned char *cp,unsigned char op0,unsigned char op1)		// op0 is ignored
{
	unsigned __int32 tmp=op1*8;
	*(cp++)=0xf7;
	*(cp++)=0xa5;
	memcpy(cp,&tmp,4);		// mul unsigned __int32 ptr [ebp+Op1*8]
	return(6);
}

unsigned __int16 IDIV(unsigned char *cp,unsigned char op0,unsigned char op1)		// op0 is ignored
{
	unsigned __int32 tmp=op1*8;
	*(cp++)=0xf7;
	*(cp++)=0xbd;
	memcpy(cp,&tmp,4);		// imul unsigned __int32 ptr [ebp+Op1*8]
	return(6);
}

unsigned __int16 DIV(unsigned char *cp,unsigned char op0,unsigned char op1)		// op0 is ignored
{
	unsigned __int32 tmp=op1*8;
	*(cp++)=0xf7;
	*(cp++)=0xb5;
	memcpy(cp,&tmp,4);		// mul unsigned __int32 ptr [ebp+Op1*8]
	return(6);
}

unsigned __int16 CONVERT_TO_QWORD(unsigned char *cp)
{
	*(cp++)=0x99;
	return(1);
}

unsigned __int16 CONVERT_TO_DWORD(unsigned char *cp)
{
	*(cp++)=0x98;
	return(1);
}

unsigned __int16 CONVERT_TO_WORD(unsigned char *cp)
{
	*(cp++)=0x66;
	*(cp++)=0x98;
	return(2);
}

unsigned __int16 REG_TO_MEM_DWORD(unsigned char *cp,unsigned __int32 DstOff,unsigned char Reg)
{
	*(cp++)=0x89;
	*(cp++)=0x80+(Reg<<3)+REG_PTR;
	memcpy(cp,&DstOff,4);
	return(6);
}

unsigned __int16 CLD(unsigned char *cp)
{
	*(cp++)=0xfc;
	return(1);
}

unsigned __int16 STD(unsigned char *cp)
{
	*(cp++)=0xfd;
	return(1);
}

unsigned __int16 REP_MOVE_STORE_BYTE(unsigned char *cp)
{
	*(cp++)=0xf3;
	*(cp++)=0xa4;
	return(2);
}

unsigned __int16 LOAD_REG_IMM(unsigned char *cp,unsigned char Reg,unsigned __int32 Immediate)
{
	*(cp++)=0xb8+Reg;
	memcpy(cp,&Immediate,4);
	return(5);
}


unsigned __int16 LOAD_REG_FROM_MEMORY(unsigned char *cp,unsigned char Reg,unsigned __int32 Address)
{
	*(cp++)=0x8b;
	*(cp++)=0x05+(Reg<<3);
	memcpy(cp,&Address,4);
	return(6);
}

unsigned __int16 CALL_CHECKINTS(unsigned char *cp)
{
	int Current=(int)cp+5;
	int Offset=dynaCheckIntsAddress-Current;
	*(cp++)=0xe8;
	memcpy(cp,&Offset,4);
	return(5);
}

unsigned __int16 JMP_REGISTER(unsigned char *cp,unsigned char reg)
{
	*(cp++)=0xff;
	*(cp++)=0xe0;
	return(2);
}

unsigned __int16 JNE_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x85;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 JE_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x84;
	memcpy(cp,&Offset,4);
	return(6);
}


unsigned __int16 JG_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x8f;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 JGE_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x8D;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 JL_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x8c;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 JLE_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x8e;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 JZ_LONG(unsigned char *cp,int Offset)		// same as JE
{
	*(cp++)=0x0f;
	*(cp++)=0x85;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 JNZ_LONG(unsigned char *cp,int Offset)		// same as JNE
{
	*(cp++)=0x0f;
	*(cp++)=0x84;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 J_LONG(unsigned char *cp,int Offset)
{
	*(cp++)=0x0f;
	*(cp++)=0x84;
	memcpy(cp,&Offset,4);
	return(6);
}

unsigned __int16 RETURN(unsigned char *cp)
{
	unsigned __int16 l=0;
//	l=STORE_DWORD_TO_RBANK(cp,dynaPC,PC_);
//	l+=STORE_DWORD_TO_RBANK(cp+l,dynaICount,ICOUNT);
//	cp+=l;
	*(cp++)=0xc3;
	l++;
	return(l);
}

/*
unsigned __int16 INC_PC_COUNTER(unsigned char *cp)
{
	unsigned __int16 l=0;

//#ifdef UseNew
	if (UseNew)
	l=ADD_REG_IMM_BYTE(cp+l,PC_PTR,4);
//#endif
	l+=INC_RBANK(cp+l,ICOUNT);
//	l+=ADD_IMM_TO_RBANK(cp+l,8,ICOUNT);
//	dynaPC+=4;
	dynaICount++;

	return(l);
}
*/
WORD INC_PC_COUNTER(BYTE *cp)
{
	WORD l=0;
	l=ADD_REG_IMM_BYTE(cp+l,PC_PTR,4);
	l+=INC_RBANK(cp+l,ICOUNT);
	return(l);
}
