
#define CORE

#include <windows.h>
#include <process.h>
#include <commctrl.h>
#include <stdio.h>
#include "Res/resource.h"
#include "driver.h"
#include "File.h"
#include "cpu_thread.h"

char bLoadedRom = 0;
extern HWND hListView;


BOOL InitInterface(void);
BOOL UnInitInterface(void);
void ResizeInterface(void);
extern void Aud_Configure();


BOOL DestroyInterface(void);
long FAR PASCAL	WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char *pFile;
    switch (message)
    {
        case WM_DESTROY:
		{
			// we need to do this BEFORE the window is trashed
			DestroyInterface();

			PostQuitMessage(0);
		}
		return 0;

		case WM_SIZE:
		{
			WinData.Width  = (int)LOWORD(lParam);
			WinData.Height = (int)HIWORD(lParam);

			ResizeInterface();
		}
		break;
		case WM_MOVE:
		{
			RECT r;
			GetWindowRect(WinData.hWnd,&r);
			WinData.PosX = r.left;
			WinData.PosY = r.top;
		}
		break;

		case WM_COMMAND:
		{
			// all menubar entries are now IDM instead of ID to avoid collisions
            switch(LOWORD(wParam))
            {
                case IDM_FILE_LOADROM:
				{
					if(bLoadedRom==1)
						PauseCPU();
					pFile = OpenNewFile("Open New Cardridge");
					if(pFile!=NULL)
					{
						if(bLoadedRom==1)
						{
							StopCPU();
							RemoveCardridge();
						}
						StartRom(pFile);
						bLoadedRom = 1;
					}
					else
					{
						if(bLoadedRom==1)
							ResumeCPU();

					}
					return 0;
				}
				case IDM_FILE_CLOSEROM:
				{
					MessageBox(WinData.hWnd, "CloseRom", szAppName, MB_OK);
					if(bLoadedRom==1)
					{
						StopCPU();
						RemoveCardridge();
						//DestroyWindow(DisplayWinData.hWnd);
					}
					bLoadedRom = 0;
					return 0L;
				}
                case IDM_FILE_EXIT:
				{
					PostQuitMessage(0);
					return 0L;
				}

				case IDM_EMULATION_RESET:
				{
					if(bLoadedRom==1)
					{
						PauseCPU();
						StopCPU();
						ResetCPU();
					}
					return 0;
				}
				case IDM_UCODE0:
				{
					Vid_SetUCode(0);
					return 0;
				}
				case IDM_UCODE1:
				{
					Vid_SetUCode(1);
					return 0;
				}
				case IDM_UCODE2:
				{
					Vid_SetUCode(2);
					return 0;
				}
				case IDM_UCODE3:
				{
					Vid_SetUCode(3);
					return 0;
				}
				case IDM_UCODE4:
				{
					Vid_SetUCode(4);
					return 0;
				}

				case IDM_OPTIONS_AUDIO:
					Aud_Configure();
					break;
				case IDM_OPTIONS_VIDEO:
				case IDM_OPTIONS_CONTROLLER:
					MessageBox(WinData.hWnd, "Not implemented yet.", szAppName, MB_OK|MB_ICONEXCLAMATION);
					return 0;
			}
		}
    }
    return DefWindowProc(hWnd, message, wParam, lParam);
}


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR szCmdLine, int iCmdShow)
{
	
	MSG     msg;
	char    *p;

	WinData.hInstance = hInstance;
	WinData.iCmdShow = iCmdShow;
	WinData.Width = 640;
	WinData.Height = 350;

	DisplayWinData.hInstance = hInstance;
	DisplayWinData.iCmdShow = 1;
	DisplayWinData.Width = 640;
	DisplayWinData.Height = 480;


	//GetFullPathName("", MAX_PATH, WinData.szDirPath, "")  
	strcpy(WinData.iniPath, GetCommandLine() + 1);

	if (strchr(WinData.iniPath,'\"')) 
	{
		p = strchr(WinData.iniPath,'\"');
		*p = '\0';
	}
	if (strchr(WinData.iniPath,'\\')) 
	{
		p = WinData.iniPath;
		while (strchr(p,'\\')) 
		{
			p = strchr(p,'\\');
			p++;
		}
		p -= 1;
		*p = '\0';
	}
	strcat(WinData.iniPath, "\\TRWinGL.ini");


	//    pwindowhandle
	if (!InitInterface())
		return -123;

	InitDrivers(WinData.hWnd, WinData.hInstance);

	if(szCmdLine != 0 && strlen(szCmdLine) != 0)
	{
		StartRom(szCmdLine);
		bLoadedRom = 1;
	}


    while (GetMessage(&msg, NULL, 0, 0))
    {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
    }


	if(bLoadedRom==1)
	{
		StopCPU();
		RemoveCardridge();
	}
	ReleaseDrivers();

    return msg.wParam; 
}
