#ifndef __SOUND_DRIVER_H__
#define __SOUND_DRIVER_H__
#ifndef __cplusplus
	#define EXTERN_	extern
#else
	#define EXTERN_	extern "C"
#endif

typedef	struct
{
	int				*pInterruptMask;
	unsigned char	*pRDRAM;
	unsigned char	*pIMEM;
	unsigned char	*pDMEM;
	unsigned char	*pVIREG;
}t_SCoreConnection;

typedef void			(*t_SoundDriverInitFunction)(void *);	
typedef	void			(*t_CreateConnectionWithCore)(t_SCoreConnection *);
typedef void			(*t_InitSound)(void *);
typedef void			(*t_ReleaseSound)();
typedef void			(*t_ExecuteSList)();

typedef	struct 
{
	t_InitSound					InitSound;
	t_ReleaseSound				ReleaseSound;
	t_CreateConnectionWithCore	CreateConnectionWithCore;
	t_ExecuteSList				ExecuteSList;
}tSoundDriver;


#ifdef CORE
	EXTERN_	void			*pWindowHandle;
	EXTERN_	char			bWindowed;
	EXTERN_	tSoundDriver	sSoundDriver;
	EXTERN_	void			InitSoundDriver(t_SoundDriverInitFunction tInitFn);
	EXTERN_	void			ReleaseSpundDriver();
	EXTERN_	void			LoadSoundDriver(const char *strSoundDriver);
#endif

#endif